diff --git a/runtime/nsd_ossl.c b/runtime/nsd_ossl.c
index c3459d7bd2..4b160880ad 100644
--- a/runtime/nsd_ossl.c
+++ b/runtime/nsd_ossl.c
@@ -196,17 +196,18 @@ void osslLastSSLErrorMsg(int ret, SSL *ssl, int severity, const char* pszCallSou
 	int iSSLErr = 0;
 	if (ssl == NULL) {
 		/* Output Error Info*/
-		dbgprintf("OpenSSL Error in '%s' with ret=%d\n", pszCallSource, ret);
+		dbgprintf("osslLastSSLErrorMsg: Error in '%s' with ret=%d\n", pszCallSource, ret);
 	} else {
 		/* if object is set, get error code */
 		iSSLErr = SSL_get_error(ssl, ret);
 
 		/* Output error message */
-		dbgprintf("OpenSSL Error '%s(%d)' in '%s' with ret=%d\n",
+		dbgprintf("osslLastSSLErrorMsg: Error '%s(%d)' in '%s' with ret=%d\n",
 			ERR_error_string(iSSLErr, NULL), iSSLErr, pszCallSource, ret);
 		if(iSSLErr == SSL_ERROR_SSL) {
 			LogMsg(0, RS_RET_NO_ERRCODE, severity, "SSL_ERROR_SSL in '%s'", pszCallSource);
 		} else if(iSSLErr == SSL_ERROR_SYSCALL){
+
 			LogMsg(0, RS_RET_NO_ERRCODE, severity, "SSL_ERROR_SYSCALL in '%s'", pszCallSource);
 		} else {
 			LogMsg(0, RS_RET_NO_ERRCODE, severity, "SSL_ERROR_UNKNOWN in '%s', SSL_get_error: '%s(%d)'",
@@ -542,6 +543,7 @@ osslRecordRecv(nsd_ossl_t *pThis)
 	ssize_t lenRcvd;
 	DEFiRet;
 	int err;
+	int local_errno;
 
 	ISOBJ_TYPE_assert(pThis, nsd_ossl);
 	DBGPRINTF("osslRecordRecv: start\n");
@@ -578,9 +580,20 @@ osslRecordRecv(nsd_ossl_t *pThis)
 		}
 		else if(err != SSL_ERROR_WANT_READ &&
 			err != SSL_ERROR_WANT_WRITE) {
-			/* Output error and abort */
+			DBGPRINTF("osslRecordRecv: SSL_get_error = %d\n", err);
+			/* Save errno */
+			local_errno = errno;
+
+			/* Output OpenSSL error*/
 			osslLastSSLErrorMsg(lenRcvd, pThis->ssl, LOG_ERR, "osslRecordRecv");
-			ABORT_FINALIZE(RS_RET_NO_ERRCODE);
+			/* Check for underlaying socket errors **/
+			if (local_errno == ECONNRESET) {
+				DBGPRINTF("osslRecordRecv: Errno %d, connection resetted by peer\n", local_errno);
+				ABORT_FINALIZE(RS_RET_CLOSED);
+			} else {
+				DBGPRINTF("osslRecordRecv: Errno %d\n", local_errno);
+				ABORT_FINALIZE(RS_RET_NO_ERRCODE);
+			}
 		} else {
 			DBGPRINTF("osslRecordRecv: SSL_get_error = %d\n", err);
 			pThis->rtryCall =  osslRtry_recv;
@@ -607,6 +620,7 @@ osslInitSession(nsd_ossl_t *pThis) /* , nsd_ossl_t *pServer) */
 	nsd_ptcp_t *pPtcp = (nsd_ptcp_t*) pThis->pTcp;
 
 	if(!(pThis->ssl = SSL_new(ctx))) {
+		pThis->ssl = NULL;
 		osslLastSSLErrorMsg(0, pThis->ssl, LOG_ERR, "osslInitSession");
 	}
 
@@ -1567,7 +1581,13 @@ Rcv(nsd_t *pNsd, uchar *pBuf, ssize_t *pLenBuf, int *const oserr)
 
 finalize_it:
 	if (iRet != RS_RET_OK) {
-		if (iRet != RS_RET_RETRY) {
+		if (iRet == RS_RET_CLOSED) {
+			if (pThis->ssl != NULL) {
+				/* Set SSL Shutdown */
+				SSL_shutdown(pThis->ssl);
+				dbgprintf("osslRcv SSL_shutdown done\n");
+			}
+		} else if (iRet != RS_RET_RETRY) {
 			/* We need to free the receive buffer in error error case unless a retry is wanted. , if we
 			 * allocated one. -- rgerhards, 2008-12-03 -- moved here by alorbach, 2015-12-01
 			 */
@@ -1575,7 +1595,7 @@ Rcv(nsd_t *pNsd, uchar *pBuf, ssize_t *pLenBuf, int *const oserr)
 			free(pThis->pszRcvBuf);
 			pThis->pszRcvBuf = NULL;
 		} else {
-			/* Check for SSL Shutdown */
+			/* RS_RET_RETRY | Check for SSL Shutdown */
 			if (SSL_get_shutdown(pThis->ssl) == SSL_RECEIVED_SHUTDOWN) {
 				dbgprintf("osslRcv received SSL_RECEIVED_SHUTDOWN!\n");
 				iRet = RS_RET_CLOSED;
@@ -1696,6 +1716,7 @@ Connect(nsd_t *pNsd, int family, uchar *port, uchar *host, char *device)
 	/*if we reach this point we are in tls mode */
 	DBGPRINTF("Connect: TLS Mode\n");
 	if(!(pThis->ssl = SSL_new(ctx))) {
+		pThis->ssl = NULL;
 		osslLastSSLErrorMsg(0, pThis->ssl, LOG_ERR, "Connect");
 		ABORT_FINALIZE(RS_RET_NO_ERRCODE);
 	}
diff --git a/tests/tcpflood.c b/tests/tcpflood.c
index 30e0a96537..1b908d1f07 100644
--- a/tests/tcpflood.c
+++ b/tests/tcpflood.c
@@ -163,6 +163,7 @@ char *test_rs_strerror_r(int errnum, char *buf, size_t buflen) {
 
 #define MAX_EXTRADATA_LEN 200*1024
 #define MAX_SENDBUF 2 * MAX_EXTRADATA_LEN
+#define MAX_RCVBUF 16 * 1024 + 1/* TLS RFC 8449: max size of buffer for message reception */
 
 static char *targetIP = "127.0.0.1";
 static char *msgPRI = "167";
@@ -508,8 +509,9 @@ void closeConnections(void)
 				ling.l_onoff = 1;
 				ling.l_linger = 1;
 				setsockopt(sockArray[i], SOL_SOCKET, SO_LINGER, &ling, sizeof(ling));
-				if(transport == TP_TLS)
+				if(transport == TP_TLS) {
 					closeTLSSess(i);
+				}
 				close(sockArray[i]);
 			}
 		}
@@ -1303,6 +1305,14 @@ closeTLSSess(int i)
 {
 	int r;
 	r = SSL_shutdown(sslArray[i]);
+	if (r <= 0){
+		/* Shutdown not finished, call SSL_read to do a bidirectional shutdown, see doc for more:
+		*	https://www.openssl.org/docs/man1.1.1/man3/SSL_shutdown.html
+		*/
+		char rcvBuf[MAX_RCVBUF];
+		SSL_read(sslArray[i], rcvBuf, MAX_RCVBUF);
+
+	}
 	SSL_free(sslArray[i]);
 }
 #	elif defined(ENABLE_GNUTLS)
